Init()
{
	if (getcvar("scr_dot_crosshair") == "" || getcvarint("scr_dot_crosshair") < 1)
		level.dotcrosshair = 0;
	else
		level.dotcrosshair = getcvarint("scr_dot_crosshair");

	dotcrosshairR = 255;
	dotcrosshairG = 0;
	dotcrosshairB = 0;

	if (getcvar("scr_dot_crosshair_red") != "")
		dotcrosshairR = getcvarint("scr_dot_crosshair_red");
	if (getcvar("scr_dot_crosshair_green") != "")
		dotcrosshairG = getcvarint("scr_dot_crosshair_green");
	if (getcvar("scr_dot_crosshair_blue") != "")
		dotcrosshairB = getcvarint("scr_dot_crosshair_blue");

	if (dotcrosshairR > 255)
		dotcrosshairR = 255;
	if (dotcrosshairG > 255)
		dotcrosshairG = 255;
	if (dotcrosshairB > 255)
		dotcrosshairB = 255;

	level.dotcrosshairR = ( int(dotcrosshairR * .39) ) * .01;
	level.dotcrosshairG = ( int(dotcrosshairG * .39) ) * .01;
	level.dotcrosshairB = ( int(dotcrosshairB * .39) ) * .01;

	if (level.dotcrosshair)
		thread OnPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player thread onPlayerSpawned();
		player thread onPlayerKilled();
	}
}

onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");

		if (!isDefined(self.dotcrosshair))
		{
			self.dotcrosshair = newClientHudElem(self);
			self.dotcrosshair.horzAlign = "center";
			self.dotcrosshair.vertAlign = "middle";
			self.dotcrosshair.x = -1;
			self.dotcrosshair.y = 0;
			self.dotcrosshair.alpha = .9;
			self.dotcrosshair.archived = true;
			self.dotcrosshair.color = (level.dotcrosshairR, level.dotcrosshairG, level.dotcrosshairB);
			self.dotcrosshair setShader("white", 2, 2);
		}
	}
}

onPlayerKilled()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("killed_player");

		if (isDefined(self.dotcrosshair))
			self.dotcrosshair destroy();
	}
}	
