Init()
{
	if(getCvar("scr_allow_secondary_select") == "")
		setCvar("scr_allow_secondary_select", 0);
	level.allow_secondary = getCvarInt("scr_allow_secondary_select");

	thread onPlayerConnect();
}

Precache()
{
	game["hud_select2ndweap"] = &"AA_WE_02";
	precacheString(game["hud_select2ndweap"]);
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player.selecting_secondary = 0;
		if ( !isDefined(player.pers["secondary_weapon"]) )
			player.pers["secondary_weapon"] = undefined;

		if (level.allow_secondary)
		{
			player thread onPlayerSpawned();
			player thread onPlayerKilled();
			player thread Second_Weap_Select();
		}
	}
}

onPlayerKilled()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("killed_player");

		if (isDefined(self.select2nd) )
				self.select2nd destroy();

		self.selecting_secondary = 0;
	}
}

onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");

		self notify("start_sec_select");
	}
}

Second_Weap_Select()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("start_sec_select");

		current_primary = self getWeaponSlotWeapon("primary");
		current_secondary = self getWeaponSlotWeapon("primaryb");

		if ( maps\mp\gametypes\_weapons::isMainWeapon(current_secondary) )
			continue;

		if ( isDefined(self.pers["secondary_weapon"]) )
		{
			self setWeaponSlotWeapon("primaryb", self.pers["secondary_weapon"]);
			self setWeaponSlotAmmo("primaryb", 999);
			self setWeaponSlotClipAmmo("primaryb", 999);
			continue;
		}

		//Secondary not selected, select it now!
		self.selecting_secondary = 1;

		self Secondary_HUD_element();

		if(self.pers["team"] == "allies")
			weap_menu = game["menu_weapon_allies"];
		else
			weap_menu = game["menu_weapon_axis"];

		self openMenu(weap_menu);

		while(self.sessionstate == "playing") 
		{
			self waittill("menuresponse", menu, response);

			if( response == "back" || (menu != game["menu_weapon_allies"] && menu != game["menu_weapon_axis"]) )
			{
				wait .05;
				self closeMenu();
				self closeInGameMenu();

				wait .05;
				self openMenu(weap_menu);
				continue;
			}

			weapon = self maps\mp\gametypes\_weapons::restrictWeaponByServerCvars(response);
			
			if(weapon == "restricted" || weapon == current_primary)
			{
				self closeMenu();
				self closeInGameMenu();

				wait .05;
				self openMenu(weap_menu);
				continue;
			}

			// We HAVE a good secondary!
			self.pers["secondary_weapon"] = weapon;
			self closeMenu();
			self closeInGameMenu();

			self setWeaponSlotWeapon("primaryb", weapon);
			self setWeaponSlotAmmo("primaryb", 999);
			self setWeaponSlotClipAmmo("primaryb", 999);

			if (isDefined(self.select2nd) )
				self.select2nd destroy();

			break;                       
		}

		wait .1;
		self.selecting_secondary = 0;
		
	}
}

Secondary_HUD_element()
{
	self.select2nd = newClientHudElem(self);
	self.select2nd.x = 320;
	self.select2nd.y = 445;
	self.select2nd.alignX = "center";
	self.select2nd.alignY = "middle";
	self.select2nd.fontScale = 1.2;
	self.select2nd.color = (1, 1, 0);
	self.select2nd.alpha = 1;
	self.select2nd setText(game["hud_select2ndweap"]);
}