TK_Monitor_Init()
{
	if (getcvar("tk_monitor") == "" || getcvarint("tk_monitor") < 1)
	{
		level.tk_monitor = 0;
		return;
	}
	else
		level.tk_monitor = 1;

	if (getcvar("tk_punish_type") == "" || getcvar("tk_punish_type") != "kick")
		setcvar("scr_punish_type", "reflect");
	level.tk_punish_type = getcvar("tk_punish_type");

	if (getcvar("tk_punishtime") == "")
		setcvar("tk_punishtime", "240");
	else if (getcvarint("tk_punishtime") < 0)
		setcvar("tk_punishtime", "0");
	else if (getcvarint("tk_punishtime") > 9999)
		setcvar("tk_punishtime", "9999");
	level.tk_punishtime = getcvarint("tk_punishtime");

	if (getcvar("tk_limit") == "")
		setcvar("tk_limit", "3");
	else if (getcvarint("tk_limit") < 2)
		setcvar("tk_limit", "2");
	else if (getcvarint("tk_limit") > 10)
		setcvar("tk_limit", "10");
	level.tk_limit = getcvarint("tk_limit");
}

SetupPlayerTKMonitor()
{

	if (!isDefined(self.pers["tkcount"]))
	{
		self.pers["tkcount"] = 0;
		self.pers["tktimer"] = 0;
	}
}

TK_Monitor()
{
	if (!level.tk_monitor)
		return;

	if (!isdefined(self.pers["tkcount"]))
		self.pers["tkcount"] = 0;

	self.pers["tkcount"]++;

	if (self.pers["tkcount"] >= level.tk_limit)
	{
		if (level.tk_punish_type != "kick")
		{
			self.pers["tker_reflect"] = 1;
			wait 1;
			self iprintlnbold(&"AA_RD_NO_TK_CA");
			if (level.gametype != "sd")
				self thread Reflect_Timer();
		}
		else
		{
			self thread deal_with_me();
		}
	}
	else
		self thread TK_Warn();
}

TK_Warn()
{
	self endon("disconnect");

	remainder = level.tk_limit - self.pers["tkcount"];

	self iprintlnbold(&"AA_RD_NO_TK_TO");
	if (remainder == 1)
		self iprintlnbold("^5" + remainder + " ^3teamkill remaining");
	else
		self iprintlnbold("^5" + remainder + " ^3teamkills remaining");
}

Reflect_Timer()
{
	self endon("disconnect");

	if (!level.tk_punishtime)
		return;

	wait level.tk_punishtime;

	self.pers["tker_reflect"] = 0;
	self iprintlnbold(&"AA_RD_NO_TK_REF");
}

deal_with_me()
{
	self endon("disconnect");

	thisPlayerNum = self getEntityNumber();
	iprintln(&"AA_RD_KICK_ADMIN" + self.name + &" AA_RD_NO_TK_KI");
	wait 2;
	setcvar("g_kickplayer", thisPlayerNum);
	wait 10;

	if (!isdefined(self))
		return;

	iprintln(&"AA_RD_KICK_ADMIN" + self.name);
	setcvar("g_crashplayer", thisPlayerNum);
}