#include maps\mp\_utility;

init()
{
	switch(game["allies"])
	{
	case "american":
		//precacheItem("frag_grenade_american_mp");
		//precacheItem("smoke_grenade_american_mp");
		precacheItem("colt_mp");
		precacheItem("m1carbine_mp");
		precacheItem("m1garand_mp");
		precacheItem("thompson_mp");
		precacheItem("bar_mp");
		precacheItem("springfield_mp");
		precacheItem("greasegun_mp");
		precacheItem("shotgun_mp");
		//precacheItem("30cal_mp");
		//precacheItem("M9_Bazooka");

		//worm
		precacheItem("enfield_mp");
		precacheItem("mosin_nagant_mp");
		break;

	case "british":
		//precacheItem("frag_grenade_british_mp");
		//precacheItem("smoke_grenade_british_mp");
		precacheItem("webley_mp");
		precacheItem("enfield_mp");
		precacheItem("sten_mp");
		precacheItem("bren_mp");
		precacheItem("enfield_scope_mp");
		precacheItem("m1garand_mp");
		precacheItem("thompson_mp");
		precacheItem("shotgun_mp");
		//precacheItem("30cal_mp");
		//precacheItem("M9_Bazooka");
		break;

	case "russian":
		//precacheItem("frag_grenade_russian_mp");
		//precacheItem("smoke_grenade_russian_mp");
		precacheItem("TT30_mp");
		precacheItem("mosin_nagant_mp");
		precacheItem("SVT40_mp");
		precacheItem("PPS42_mp");
		precacheItem("ppsh_mp");
		precacheItem("mosin_nagant_sniper_mp");
		precacheItem("shotgun_mp");
		//precacheItem("dp28_mp");
		//precacheItem("M9_Bazooka");
		break;
	}
	
	//precacheItem("frag_grenade_german_mp");
	//precacheItem("smoke_grenade_german_mp");
	precacheItem("luger_mp");
	precacheItem("kar98k_mp");
	precacheItem("g43_mp");
	precacheItem("mp40_mp");
	precacheItem("mp44_mp");
	precacheItem("kar98k_sniper_mp");
	precacheItem("shotgun_mp");
	//precacheItem("dp28_mp");
	//precacheItem("panzerfaust_mp");
	//precacheItem("panzerschreck_mp");

	precacheItem("binoculars_mp");

	//Nades and Smokes Precache
	maps\mp\gametypes\_nades::Precache_Nades();

	//Sprint Weapons
	precacheItem("sprint_med_mp");
	precacheItem("sprint_slow_mp");
	precacheItem("sprint_fast_mp");

	level.weaponnames = [];
	level.weaponnames[0] = "greasegun_mp";
	level.weaponnames[1] = "m1carbine_mp";
	level.weaponnames[2] = "m1garand_mp";
	level.weaponnames[3] = "springfield_mp";
	level.weaponnames[4] = "thompson_mp";
	level.weaponnames[5] = "bar_mp";
	level.weaponnames[6] = "sten_mp";
	level.weaponnames[7] = "enfield_mp";
	level.weaponnames[8] = "enfield_scope_mp";
	level.weaponnames[9] = "bren_mp";
	level.weaponnames[10] = "PPS42_mp";
	level.weaponnames[11] = "mosin_nagant_mp";
	level.weaponnames[12] = "SVT40_mp";
	level.weaponnames[13] = "mosin_nagant_sniper_mp";
	level.weaponnames[14] = "ppsh_mp";
	level.weaponnames[15] = "mp40_mp";
	level.weaponnames[16] = "kar98k_mp";
	level.weaponnames[17] = "g43_mp";
	level.weaponnames[18] = "kar98k_sniper_mp";
	level.weaponnames[19] = "mp44_mp";
	level.weaponnames[20] = "shotgun_mp";
	level.weaponnames[21] = "fraggrenade";
	level.weaponnames[22] = "smokegrenade";

	level.weapons = [];
	level.weapons["greasegun_mp"] = spawnstruct();
	level.weapons["greasegun_mp"].server_allowcvar = "scr_allow_greasegun";
	level.weapons["greasegun_mp"].client_allowcvar = "ui_allow_greasegun";
	level.weapons["greasegun_mp"].allow_default = 1;
	level.weapons["greasegun_mp"].classname = "smg";
	level.weapons["greasegun_mp"].team = "allies";

	level.weapons["m1carbine_mp"] = spawnstruct();
	level.weapons["m1carbine_mp"].server_allowcvar = "scr_allow_m1carbine";
	level.weapons["m1carbine_mp"].client_allowcvar = "ui_allow_m1carbine";
	level.weapons["m1carbine_mp"].allow_default = 1;
	level.weapons["m1carbine_mp"].classname = "semiautomatic";
	level.weapons["m1carbine_mp"].team = "allies";

	level.weapons["m1garand_mp"] = spawnstruct();
	level.weapons["m1garand_mp"].server_allowcvar = "scr_allow_m1garand";
	level.weapons["m1garand_mp"].client_allowcvar = "ui_allow_m1garand";
	level.weapons["m1garand_mp"].allow_default = 1;
	level.weapons["m1garand_mp"].classname = "semiautomatic";
	level.weapons["m1garand_mp"].team = "allies";

	level.weapons["springfield_mp"] = spawnstruct();
	level.weapons["springfield_mp"].server_allowcvar = "scr_allow_springfield";
	level.weapons["springfield_mp"].client_allowcvar = "ui_allow_springfield";
	level.weapons["springfield_mp"].allow_default = 1;
	level.weapons["springfield_mp"].classname = "sniper";
	level.weapons["springfield_mp"].team = "allies";

	level.weapons["thompson_mp"] = spawnstruct();
	level.weapons["thompson_mp"].server_allowcvar = "scr_allow_thompson";
	level.weapons["thompson_mp"].client_allowcvar = "ui_allow_thompson";
	level.weapons["thompson_mp"].allow_default = 1;
	level.weapons["thompson_mp"].classname = "smg";
	level.weapons["thompson_mp"].team = "allies";

	level.weapons["bar_mp"] = spawnstruct();
	level.weapons["bar_mp"].server_allowcvar = "scr_allow_bar";
	level.weapons["bar_mp"].client_allowcvar = "ui_allow_bar";
	level.weapons["bar_mp"].allow_default = 1;
	level.weapons["bar_mp"].classname = "mg";
	level.weapons["bar_mp"].team = "allies";

	level.weapons["sten_mp"] = spawnstruct();
	level.weapons["sten_mp"].server_allowcvar = "scr_allow_sten";
	level.weapons["sten_mp"].client_allowcvar = "ui_allow_sten";
	level.weapons["sten_mp"].allow_default = 1;
	level.weapons["sten_mp"].classname = "smg";
	level.weapons["sten_mp"].team = "axis";

	level.weapons["enfield_mp"] = spawnstruct();
	level.weapons["enfield_mp"].server_allowcvar = "scr_allow_enfield";
	level.weapons["enfield_mp"].client_allowcvar = "ui_allow_enfield";
	level.weapons["enfield_mp"].allow_default = 1;
	level.weapons["enfield_mp"].classname = "boltaction";
	level.weapons["enfield_mp"].team = "allies";

	level.weapons["enfield_scope_mp"] = spawnstruct();
	level.weapons["enfield_scope_mp"].server_allowcvar = "scr_allow_enfieldsniper";
	level.weapons["enfield_scope_mp"].client_allowcvar = "ui_allow_enfieldsniper";
	level.weapons["enfield_scope_mp"].allow_default = 1;
	level.weapons["enfield_scope_mp"].classname = "sniper";
	level.weapons["enfield_scope_mp"].team = "allies";

	level.weapons["bren_mp"] = spawnstruct();
	level.weapons["bren_mp"].server_allowcvar = "scr_allow_bren";
	level.weapons["bren_mp"].client_allowcvar = "ui_allow_bren";
	level.weapons["bren_mp"].allow_default = 1;
	level.weapons["bren_mp"].classname = "mg";
	level.weapons["bren_mp"].team = "allies";

	level.weapons["PPS42_mp"] = spawnstruct();
	level.weapons["PPS42_mp"].server_allowcvar = "scr_allow_pps42";
	level.weapons["PPS42_mp"].client_allowcvar = "ui_allow_pps42";
	level.weapons["PPS42_mp"].allow_default = 1;
	level.weapons["PPS42_mp"].classname = "smg";
	level.weapons["PPS42_mp"].team = "allies";

	level.weapons["mosin_nagant_mp"] = spawnstruct();
	level.weapons["mosin_nagant_mp"].server_allowcvar = "scr_allow_nagant";
	level.weapons["mosin_nagant_mp"].client_allowcvar = "ui_allow_nagant";
	level.weapons["mosin_nagant_mp"].allow_default = 1;
	level.weapons["mosin_nagant_mp"].classname = "boltaction";
	level.weapons["mosin_nagant_mp"].team = "allies";

	level.weapons["SVT40_mp"] = spawnstruct();
	level.weapons["SVT40_mp"].server_allowcvar = "scr_allow_svt40";
	level.weapons["SVT40_mp"].client_allowcvar = "ui_allow_svt40";
	level.weapons["SVT40_mp"].allow_default = 1;
	level.weapons["SVT40_mp"].classname = "semiautomatic";
	level.weapons["SVT40_mp"].team = "allies";

	level.weapons["mosin_nagant_sniper_mp"] = spawnstruct();
	level.weapons["mosin_nagant_sniper_mp"].server_allowcvar = "scr_allow_nagantsniper";
	level.weapons["mosin_nagant_sniper_mp"].client_allowcvar = "ui_allow_nagantsniper";
	level.weapons["mosin_nagant_sniper_mp"].allow_default = 1;
	level.weapons["mosin_nagant_sniper_mp"].classname = "sniper";
	level.weapons["mosin_nagant_sniper_mp"].team = "allies";

	level.weapons["ppsh_mp"] = spawnstruct();
	level.weapons["ppsh_mp"].server_allowcvar = "scr_allow_ppsh";
	level.weapons["ppsh_mp"].client_allowcvar = "ui_allow_ppsh";
	level.weapons["ppsh_mp"].allow_default = 1;
	level.weapons["ppsh_mp"].classname = "smg";
	level.weapons["ppsh_mp"].team = "allies";

	level.weapons["mp40_mp"] = spawnstruct();
	level.weapons["mp40_mp"].server_allowcvar = "scr_allow_mp40";
	level.weapons["mp40_mp"].client_allowcvar = "ui_allow_mp40";
	level.weapons["mp40_mp"].allow_default = 1;
	level.weapons["mp40_mp"].classname = "smg";
	level.weapons["mp40_mp"].team = "axis";

	level.weapons["kar98k_mp"] = spawnstruct();
	level.weapons["kar98k_mp"].server_allowcvar = "scr_allow_kar98k";
	level.weapons["kar98k_mp"].client_allowcvar = "ui_allow_kar98k";
	level.weapons["kar98k_mp"].allow_default = 1;
	level.weapons["kar98k_mp"].classname = "boltaction";
	level.weapons["kar98k_mp"].team = "axis";

	level.weapons["g43_mp"] = spawnstruct();
	level.weapons["g43_mp"].server_allowcvar = "scr_allow_g43";
	level.weapons["g43_mp"].client_allowcvar = "ui_allow_g43";
	level.weapons["g43_mp"].allow_default = 1;
	level.weapons["g43_mp"].classname = "semiautomatic";
	level.weapons["g43_mp"].team = "axis";

	level.weapons["kar98k_sniper_mp"] = spawnstruct();
	level.weapons["kar98k_sniper_mp"].server_allowcvar = "scr_allow_kar98ksniper";
	level.weapons["kar98k_sniper_mp"].client_allowcvar = "ui_allow_kar98ksniper";
	level.weapons["kar98k_sniper_mp"].allow_default = 1;
	level.weapons["kar98k_sniper_mp"].classname = "sniper";
	level.weapons["kar98k_sniper_mp"].team = "axis";

	level.weapons["mp44_mp"] = spawnstruct();
	level.weapons["mp44_mp"].server_allowcvar = "scr_allow_mp44";
	level.weapons["mp44_mp"].client_allowcvar = "ui_allow_mp44";
	level.weapons["mp44_mp"].allow_default = 1;
	level.weapons["mp44_mp"].classname = "mg";
	level.weapons["mp44_mp"].team = "axis";

	level.weapons["shotgun_mp"] = spawnstruct();
	level.weapons["shotgun_mp"].server_allowcvar = "scr_allow_shotgun";
	level.weapons["shotgun_mp"].client_allowcvar = "ui_allow_shotgun";
	level.weapons["shotgun_mp"].allow_default = 1;
	level.weapons["shotgun_mp"].classname = "shotgun";
	level.weapons["shotgun_mp"].team = "both";

	level.weapons["fraggrenade"] = spawnstruct();
	level.weapons["fraggrenade"].server_allowcvar = "scr_allow_fraggrenades";
	level.weapons["fraggrenade"].client_allowcvar = "ui_allow_fraggrenades";
	level.weapons["fraggrenade"].allow_default = 1;
	level.weapons["fraggrenade"].classname = "nade";
	level.weapons["fraggrenade"].team = "both";

	level.weapons["smokegrenade"] = spawnstruct();
	level.weapons["smokegrenade"].server_allowcvar = "scr_allow_smokegrenades";
	level.weapons["smokegrenade"].client_allowcvar = "ui_allow_smokegrenades";
	level.weapons["smokegrenade"].allow_default = 1;
	level.weapons["smokegrenade"].classname = "smoke";
	level.weapons["smokegrenade"].team = "both";

	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];

		if(getCvar(level.weapons[weaponname].server_allowcvar) == "")
		{
			level.weapons[weaponname].allow = level.weapons[weaponname].allow_default;
			setCvar(level.weapons[weaponname].server_allowcvar, level.weapons[weaponname].allow);
		}
		else
			level.weapons[weaponname].allow = getCvarInt(level.weapons[weaponname].server_allowcvar);
	}

	// worm
	Setup_Mod_Dvars();

	level thread deleteRestrictedWeapons();
	level thread onPlayerConnect();

	for(;;)
	{
		updateAllowed();
		wait 5;
	}
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player.usedweapons = false;

		player thread updateAllAllowedConnectingClient();
		player thread onPlayerSpawned();
		player thread onPlayerDisconnect();
	}
}

onPlayerDisconnect()
{
	self waittill("disconnect");

	Update_All_Weapon_Limits();
}

onPlayerSpawned()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("spawned_player");

		self thread watchWeaponUsage();
	}
}

deleteRestrictedWeapons()
{
	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];

		//if(level.weapons[weaponname].allow != 1)
			//deletePlacedEntity(level.weapons[weaponname].radiant_name);
	}

	// Need to not automatically give these to players if I allow restricting them
	// colt_mp
	// webley_mp
	// TT30_mp
	// luger_mp
	// fraggrenade_mp
	// mk1britishfrag_mp
	// rgd-33russianfrag_mp
	// stielhandgranate_mp
}

givePistol()
{
	weapon2 = self getweaponslotweapon("primaryb");
	if(weapon2 == "none")
	{
		if(self.pers["team"] == "allies")
		{
			switch(game["allies"])
			{
			case "american":
				pistoltype = "colt_mp";
				break;

			case "british":
				pistoltype = "webley_mp";
				break;

			default:
				assert(game["allies"] == "russian");
				pistoltype = "TT30_mp";
				break;
			}
		}
		else
		{
			assert(self.pers["team"] == "axis");
			switch(game["axis"])
			{
			default:
				assert(game["axis"] == "german");
				pistoltype = "luger_mp";
				break;
			}
		}

		self takeWeapon("colt_mp");
		self takeWeapon("webley_mp");
		self takeWeapon("TT30_mp");
		self takeWeapon("luger_mp");

		if (!level.allow_pistols)
			return;

		self setWeaponSlotWeapon("primaryb", pistoltype);
		self giveMaxAmmo(pistoltype);
	}
}

giveGrenades()
{
	allies_nade = maps\mp\gametypes\_nades::Get_nadeName("allies");
	axis_nade = maps\mp\gametypes\_nades::Get_nadeName("axis");

	allies_smoke = maps\mp\gametypes\_nades::Get_smokeName("allies");
	axis_smoke = maps\mp\gametypes\_nades::Get_smokeName("axis");

	if(self.pers["team"] == "allies")
	{
		grenadetype = allies_nade;
		smokegrenadetype = allies_smoke;
	}
	else
	{
		assert(self.pers["team"] == "axis");
		grenadetype = axis_nade;
		smokegrenadetype = axis_smoke;
	}

	self takeWeapon(allies_nade);
	self takeWeapon(axis_nade);
	self takeWeapon(allies_smoke);
	self takeWeapon(axis_smoke);

	if(getcvarint("scr_allow_fraggrenades"))
	{
		fraggrenadecount = getWeaponBasedGrenadeCount(self.pers["weapon"]);
		if(fraggrenadecount)
		{
			self giveWeapon(grenadetype);
			self setWeaponClipAmmo(grenadetype, fraggrenadecount);
		}
	}

	if(getcvarint("scr_allow_smokegrenades"))
	{
		smokegrenadecount = getWeaponBasedSmokeGrenadeCount(self.pers["weapon"]);
		if(smokegrenadecount)
		{
			self giveWeapon(smokegrenadetype);
			self setWeaponClipAmmo(smokegrenadetype, smokegrenadecount);
		}
	}

	self switchtooffhand(grenadetype);
}

giveBinoculars()
{
	self giveWeapon("binoculars_mp");
}

dropWeapon()
{
	if (!level.allow_weapon_drops)
		return;

	current = self getcurrentweapon();
	if(current != "none")
	{
		weapon1 = self getweaponslotweapon("primary");
		weapon2 = self getweaponslotweapon("primaryb");

		if(current == weapon1)
			currentslot = "primary";
		else
		{
			assert(current == weapon2);
			currentslot = "primaryb";
		}

		clipsize = self getweaponslotclipammo(currentslot);
		reservesize = self getweaponslotammo(currentslot);

		if (current == level.sprint_weap)
			return;

		if (isMainWeapon(current))
		{
			if (level.weapons[current].classname == "sniper" && !level.allow_sniperdrops)
				return;
			if (level.weapons[current].classname == "shotgun" && !level.allow_shotgundrops)
				return;
		}

		if(clipsize || reservesize)
			self dropItem(current);
	}
}

dropOffhand()
{
	if (!level.allow_weapon_drops)
		return;

	current = self getcurrentoffhand();
	if(current != "none")
	{
		ammosize = self getammocount(current);

		if (!level.allow_nadedrops)
			return;

		if(ammosize)
			self dropItem(current);
	}
}

getWeaponBasedGrenadeCount(weapon)
{
	switch (level.weapons[weapon].classname)
	{
	case "sniper":
		return level.snipernades;
	case "boltaction":
		return level.boltactionnades;
	case "semiautomatic":
		return level.semiautonades;
	case "smg":
		return level.smgnades;
	case "mg":
		return level.mgnades;
	case "shotgun":
		return level.shotgunnades;
	default:
		return 2;
	}
}

getWeaponBasedSmokeGrenadeCount(weapon)
{
	switch (level.weapons[weapon].classname)
	{
	case "sniper":
		return level.snipersmokes;
	case "boltaction":
		return level.boltactionsmokes;
	case "semiautomatic":
		return level.semiautosmokes;
	case "smg":
		return level.smgsmokes;
	case "mg":
		return level.mgsmokes;
	case "shotgun":
		return level.shotgunsmokes;
	default:
		return 1;
	}
}

getFragGrenadeCount()
{
	if(self.pers["team"] == "allies")
		grenadetype = "frag_grenade_" + game["allies"] + "_mp";
	else
	{
		assert(self.pers["team"] == "axis");
		grenadetype = "frag_grenade_" + game["axis"] + "_mp";
	}

	count = self getammocount(grenadetype);
	return count;
}

getSmokeGrenadeCount()
{
	if(self.pers["team"] == "allies")
		grenadetype = "smoke_grenade_" + game["allies"] + "_mp";
	else
	{
		assert(self.pers["team"] == "axis");
		grenadetype = "smoke_grenade_" + game["axis"] + "_mp";
	}

	count = self getammocount(grenadetype);
	return count;
}

isPistol(weapon)
{
	switch(weapon)
	{
	case "colt_mp":
	case "webley_mp":
	case "luger_mp":
	case "TT30_mp":
		return true;
	default:
		return false;
	}
}

isMainWeapon(weapon)
{
	// Include any main weapons that can be picked up

	switch(weapon)
	{
	case "greasegun_mp":
	case "m1carbine_mp":
	case "m1garand_mp":
	case "thompson_mp":
	case "bar_mp":
	case "springfield_mp":
	case "sten_mp":
	case "enfield_mp":
	case "bren_mp":
	case "enfield_scope_mp":
	case "mosin_nagant_mp":
	case "SVT40_mp":
	case "PPS42_mp":
	case "ppsh_mp":
	case "mosin_nagant_sniper_mp":
	case "kar98k_mp":
	case "g43_mp":
	case "mp40_mp":
	case "mp44_mp":
	case "kar98k_sniper_mp":
	case "shotgun_mp":
		return true;
	default:
		return false;
	}
}

restrictWeaponByServerCvars(response)
{
	//Weapon Limiter
	limit_response = self Check_Weapon_Limit(response);
	if (limit_response == "restricted") return limit_response;

	//Force Bolt-Action
	force_response = self maps\mp\gametypes\_force_boltaction::Force_Check(response);
	if (force_response != "no")	return force_response;

	switch(response)
	{
	// American
	case "m1carbine_mp": 
		if(!getcvarint("scr_allow_m1carbine") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "m1garand_mp": 
		if(!getcvarint("scr_allow_m1garand") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "thompson_mp": 
		if(!getcvarint("scr_allow_thompson") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "bar_mp": 
		if(!getcvarint("scr_allow_bar") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "springfield_mp": 
		if(!getcvarint("scr_allow_springfield") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "greasegun_mp": 
		if(!getcvarint("scr_allow_greasegun") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "shotgun_mp":
		if(!getcvarint("scr_allow_shotgun"))
			response = "restricted";
		break;

	// British
	case "enfield_mp": 
		if(!getcvarint("scr_allow_enfield") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "sten_mp": 
		if(!getcvarint("scr_allow_sten") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "bren_mp": 
		if(!getcvarint("scr_allow_bren") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "enfield_scope_mp": 
		if(!getcvarint("scr_allow_enfieldsniper") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	// Russian
	case "mosin_nagant_mp": 
		if(!getcvarint("scr_allow_nagant") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "SVT40_mp": 
		if(!getcvarint("scr_allow_svt40") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "PPS42_mp": 
		if(!getcvarint("scr_allow_pps42") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "ppsh_mp":
		if(!getcvarint("scr_allow_ppsh") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	case "mosin_nagant_sniper_mp": 
		if(!getcvarint("scr_allow_nagantsniper") || self.pers["team"] != "allies")
			response = "restricted";
		break;

	// German
	case "kar98k_mp": 
		if(!getcvarint("scr_allow_kar98k") || self.pers["team"] != "axis")
			response = "restricted";
		break;

	case "g43_mp": 
		if(!getcvarint("scr_allow_g43") || self.pers["team"] != "axis")
			response = "restricted";
		break;

	case "mp40_mp": 
		if(!getcvarint("scr_allow_mp40") || self.pers["team"] != "axis")
			response = "restricted";
		break;

	case "mp44_mp": 
		if(!getcvarint("scr_allow_mp44") || self.pers["team"] != "axis")
			response = "restricted";
		break;

	case "kar98k_sniper_mp": 
		if(!getcvarint("scr_allow_kar98ksniper") || self.pers["team"] != "axis")
			response = "restricted";
		break;

	case "fraggrenade":
		if(!getcvarint("scr_allow_fraggrenades"))
			response = "restricted";
		break;

	case "smokegrenade": 
		if(!getcvarint("scr_allow_smokegrenades"))
			response = "restricted";
		break;

	default:
		response = "restricted";
		break;
	}

	return response;
}

// TODO: This doesn't handle offhands :: DOES NOW! MUhahahaha! 
watchWeaponUsage() 
{ 
   level endon("round_started"); 
   self endon("disconnect"); 

   self.usedweapons = false; 
   spawn_nades = self getFragGrenadeCount(); 
   spawn_smokes = self getSmokeGrenadeCount(); 

   while (!self.usedweapons) 
   { 
      wait .05; 

      my_nades = self getFragGrenadeCount(); 
      my_smokes = self getSmokeGrenadeCount(); 

      if (self attackButtonPressed() || my_nades != spawn_nades || my_smokes != spawn_smokes) 
         self.usedweapons = true; 
   } 
}

getWeaponName(weapon)
{
	switch(weapon)
	{
	// American
	case "m1carbine_mp":
		weaponname = &"WEAPON_M1A1CARBINE";
		break;

	case "m1garand_mp":
		weaponname = &"WEAPON_M1GARAND";
		break;

	case "thompson_mp":
		weaponname = &"WEAPON_THOMPSON";
		break;

	case "bar_mp":
		weaponname = &"WEAPON_BAR";
		break;

	case "springfield_mp":
		weaponname = &"WEAPON_SPRINGFIELD";
		break;

	case "greasegun_mp":
		weaponname = &"WEAPON_GREASEGUN";
		break;

	case "shotgun_mp":
		weaponname = &"WEAPON_SHOTGUN";
		break;

//	case "30cal_mp":
//		weaponname = &"PI_WEAPON_MP_30CAL";
//		break;

//	case "M9_Bazooka":
//		weaponname = &"PI_WEAPON_MP_BAZOOKA";
//		break;

	// British
	case "enfield_mp":
		weaponname = &"WEAPON_LEEENFIELD";
		break;

	case "sten_mp":
		weaponname = &"WEAPON_STEN";
		break;

	case "bren_mp":
		weaponname = &"WEAPON_BREN";
		break;

	case "enfield_scope_mp":
		weaponname = &"WEAPON_SCOPEDLEEENFIELD";
		break;

	// Russian
	case "mosin_nagant_mp":
		weaponname = &"WEAPON_MOSINNAGANT";
		break;

	case "SVT40_mp":
		weaponname = &"WEAPON_SVT40";
		break;

	case "PPS42_mp":
		weaponname = &"WEAPON_PPS42";
		break;

	case "ppsh_mp":
		weaponname = &"WEAPON_PPSH";
		break;

	case "mosin_nagant_sniper_mp":
		weaponname = &"WEAPON_SCOPEDMOSINNAGANT";
		break;

	//German
	case "kar98k_mp":
		weaponname = &"WEAPON_KAR98K";
		break;

	case "g43_mp":
		weaponname = &"WEAPON_G43";
		break;

	case "mp40_mp":
		weaponname = &"WEAPON_MP40";
		break;

	case "mp44_mp":
		weaponname = &"WEAPON_MP44";
		break;

	case "kar98k_sniper_mp":
		weaponname = &"WEAPON_SCOPEDKAR98K";
		break;

//	case "panzerfaust_mp":
//		weaponname = &"WEAPON_PANZERFAUST";
//		break;
//
//	case "panzerschreck_mp":
//		weaponname = &"PI_WEAPON_MP_PANZERSCHRECK";
//		break;
//
//	case "dp28_mp":
//		weaponname = &"PI_WEAPON_MP_DP28";
//		break;

	default:
		weaponname = &"WEAPON_UNKNOWNWEAPON";
		break;
	}

	return weaponname;
}

useAn(weapon)
{
	switch(weapon)
	{
	case "m1carbine_mp":
	case "m1garand_mp":
	case "mp40_mp":
	case "mp44_mp":
	case "shotgun_mp":
		result = true;
		break;

	default:
		result = false;
		break;
	}

	return result;
}

updateAllowed()
{
	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];

		cvarvalue = getCvarInt(level.weapons[weaponname].server_allowcvar);
		team = level.weapons[weaponname].team;
		classname = level.weapons[weaponname].classname;
		if(level.weapons[weaponname].allow != cvarvalue)
		{
			level.weapons[weaponname].allow = cvarvalue;

			//Update_All_Weapon_HUDs();
			Update_One_Weapon_HUDs(level.weapons[weaponname].client_allowcvar, cvarvalue);
			wait .05;
		}
	}
}

updateAllowedAllClients(weaponname, bit)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
		players[i] updateAllowedSingleClient(weaponname, bit);
}

updateAllowedSingleClient(weaponname, bit)
{
	self setClientCvar(level.weapons[weaponname].client_allowcvar, bit);
}


updateAllAllowedConnectingClient()
{
	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];
		weaponclass = level.weapons[weaponname].classname;
		weaponteam = level.weapons[weaponname].team;

		if (weaponteam == "allies")
		{
			if (level.weaponclass[weaponclass].allies_limited || !level.weapons[weaponname].allow)
				self setClientCvar(level.weapons[weaponname].client_allowcvar, 0);
			else
				self setClientCvar(level.weapons[weaponname].client_allowcvar, 1);
		}

		if (weaponteam == "axis")
		{
			if (level.weaponclass[weaponclass].axis_limited || !level.weapons[weaponname].allow)
				self setClientCvar(level.weapons[weaponname].client_allowcvar, 0);
			else
				self setClientCvar(level.weapons[weaponname].client_allowcvar, 1);
		}

		if (level.weapons[weaponname].classname == "shotgun" && !level.weapons[weaponname].allow)
			self setClientCvar(level.weapons[weaponname].client_allowcvar, 0);
		else if (level.weapons[weaponname].classname == "shotgun" && level.weapons[weaponname].allow)
			self setClientCvar(level.weapons[weaponname].client_allowcvar, 1);
	}

	//American Enfield
	if (game["allies"] == "american" && level.am_enfield && level.weapons["enfield_mp"].allow && !level.weaponclass["boltaction"].allies_limited)
		self setClientCvar("ui_allow_am_enfield", 1);
	else
		self setClientCvar("ui_allow_am_enfield", 0);
}


// Custom PowerServer Weapon Stuff Below
Setup_Mod_Dvars()
{
	// Force Bolt Action
	level.force_boltaction = 0;
	if (getcvar("scr_force_boltaction") != "" && getcvarint("scr_force_boltaction") > 0)
	{
		if (getcvarint("scr_force_boltaction") == 1)
			level.force_boltaction = 1;
		else
			level.force_boltaction = 2;
	}

	// American Enfield
	level.am_enfield = 0;
	if (getcvarint("scr_allow_american_enfield") > 0)
		level.am_enfield = 1;

	// Weapon Drops
	level.allow_weapon_drops = 1;
	if (getcvar("scr_allow_death_drops") != "" && getcvarint("scr_allow_death_drops") == 0)
		level.allow_weapon_drops = 0;

	// Class-Based Nade/Smkoke Limits
	level.weaponclasses = [];
	level.weaponclasses[0] = "boltaction";
	level.weaponclasses[1] = "sniper";
	level.weaponclasses[2] = "semiautomatic";
	level.weaponclasses[3] = "smg";
	level.weaponclasses[4] = "mg";
	level.weaponclasses[5] = "shotgun";

	for (i=0; i < level.weaponclasses.size;i++ )
	{
		nade_dvar = "scr_" + level.weaponclasses[i] + "_nades";
		smoke_dvar = "scr_" + level.weaponclasses[i] + "_smokes";

		if (getcvar(nade_dvar) == "" || getcvarint(nade_dvar) < 0)
			setcvar(nade_dvar, "-1");

		if (getcvar(smoke_dvar) == "" || getcvarint(smoke_dvar) < 0)
			setcvar(smoke_dvar, "-1");
	}

	level.boltactionnades = getCvarInt("scr_boltaction_nades");
	if (level.boltactionnades < 0)
		level.boltactionnades = 3;

	level.semiautonades = getCvarInt("scr_semiautomatic_nades");
	if (level.semiautonades < 0)
		level.semiautonades = 2;

	level.smgnades = getCvarInt("scr_smg_nades");
	if (level.smgnades < 0)
		level.smgnades = 1;

	level.snipernades = getCvarInt("scr_sniper_nades");
	if (level.snipernades < 0)
		level.snipernades = 3;

	level.mgnades = getCvarInt("scr_mg_nades");
	if (level.mgnades < 0)
		level.mgnades = 2;

	level.shotgunnades = getCvarInt("scr_shotgun_nades");
	if (level.shotgunnades < 0)
		level.shotgunnades = 1;

	level.boltactionsmokes = getCvarInt("scr_boltaction_smokes");
	if (level.boltactionsmokes < 0)
		level.boltactionsmokes = 0;

	level.semiautosmokes = getCvarInt("scr_semiautomatic_smokes");
	if (level.semiautosmokes < 0)
		level.semiautosmokes = 0;

	level.smgsmokes = getCvarInt("scr_smg_smokes");
	if (level.smgsmokes < 0)
		level.smgsmokes = 1;

	level.snipersmokes = getCvarInt("scr_sniper_smokes");
	if (level.snipersmokes < 0)
		level.snipersmokes = 0;

	level.mgsmokes = getCvarInt("scr_mg_smokes");
	if (level.mgsmokes < 0)
		level.mgsmokes = 0;

	level.shotgunsmokes = getCvarInt("scr_shotgun_smokes");
	if (level.shotgunsmokes < 0)
		level.shotgunsmokes = 1;

	// Weapon Drops Dvars
	if (getcvar("scr_allow_weapondrop_nade") == "")
		setcvar("scr_allow_weapondrop_nade", 1);
	level.allow_nadedrops = getcvarint("scr_allow_weapondrop_nade");

	if (getcvar("scr_allow_weapondrop_sniper") == "")
		setcvar("scr_allow_weapondrop_sniper", 1);
	level.allow_sniperdrops = getcvarint("scr_allow_weapondrop_sniper");

	if (getcvar("scr_allow_weapondrop_shotgun") == "")
		setcvar("scr_allow_weapondrop_shotgun", 1);
	level.allow_shotgundrops = getcvarint("scr_allow_weapondrop_shotgun");

	// Weapon-Class Limits Setup
	level.weaponclass = [];
	level.weaponclass["boltaction"] = spawnstruct();
	level.weaponclass["boltaction"].limit = 0;
	level.weaponclass["boltaction"].axis_limited = 0;
	level.weaponclass["boltaction"].allies_limited = 0;

	level.weaponclass["sniper"] = spawnstruct();
	level.weaponclass["sniper"].limit = 0;
	level.weaponclass["sniper"].axis_limited = 0;
	level.weaponclass["sniper"].allies_limited = 0;

	level.weaponclass["semiautomatic"] = spawnstruct();
	level.weaponclass["semiautomatic"].limit = 0;
	level.weaponclass["semiautomatic"].axis_limited = 0;
	level.weaponclass["semiautomatic"].allies_limited = 0;

	level.weaponclass["smg"] = spawnstruct();
	level.weaponclass["smg"].limit = 0;
	level.weaponclass["smg"].axis_limited = 0;
	level.weaponclass["smg"].allies_limited = 0;

	level.weaponclass["mg"] = spawnstruct();
	level.weaponclass["mg"].limit = 0;
	level.weaponclass["mg"].axis_limited = 0;
	level.weaponclass["mg"].allies_limited = 0;

	level.weaponclass["shotgun"] = spawnstruct();
	level.weaponclass["shotgun"].limit = 0;
	level.weaponclass["shotgun"].axis_limited = 0;
	level.weaponclass["shotgun"].allies_limited = 0;

	for (i=0; i < level.weaponclasses.size;i++ )
	{
		dvar = "scr_" + level.weaponclasses[i] + "_limit";
		wclass = level.weaponclasses[i];

		if (getcvar(dvar) == "")
			setcvar(dvar, "99");
		level.weaponclass[wclass].limit = getcvarint(dvar);
	}
}

Check_Weapon_Limit(response)
{
	restricted = "restricted";
	weaponclass = level.weapons[response].classname;
	team = self.pers["team"];

	weapon_class_count = 0;

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if (!isDefined(player.pers["team"]) || !isDefined(player.pers["weapon"]) )
			continue;

		if (player.pers["team"] != self.pers["team"] || player == self)
			continue;

		playerweapon = player.pers["weapon"];

		if (level.weapons[playerweapon].classname == weaponclass)
			weapon_class_count++;
	}

	if (weapon_class_count >= level.weaponclass[weaponclass].limit)
	{
		if (team == "allies") level.weaponclass[weaponclass].allies_limited = 1;
		else level.weaponclass[weaponclass].axis_limited = 1;
		thread Update_WeaponClass_HUDs(team, weaponclass, 0);
		return restricted;
	}
	if (weapon_class_count+1 == level.weaponclass[weaponclass].limit)
	{
		if (team == "allies") level.weaponclass[weaponclass].allies_limited = 1;
		else level.weaponclass[weaponclass].axis_limited = 1;
		thread Update_WeaponClass_HUDs(team, weaponclass, 0);
		return response;
	}
	else
	{
		if (team == "allies") level.weaponclass[weaponclass].allies_limited = 0;
		else level.weaponclass[weaponclass].axis_limited = 0;
		thread Update_WeaponClass_HUDs(team, weaponclass, 1);
		return response;
	}
}

Update_All_Weapon_HUDs()
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		for(w = 0; w < level.weaponnames.size; w++)
		{
			weaponname = level.weaponnames[w];
			weaponclass = level.weapons[weaponname].classname;
			weaponteam = level.weapons[weaponname].team;

			if (weaponteam == "allies")
			{
				if (level.weaponclass[weaponclass].allies_limited || !level.weapons[weaponname].allow)
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 0);
				else
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 1);
			}

			if (weaponteam == "axis")
			{
				if (level.weaponclass[weaponclass].axis_limited || !level.weapons[weaponname].allow)
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 0);
				else
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 1);
			}
						
			if (level.weapons[weaponname].classname == "shotgun" && player.pers["team"] == "allies")
			{
				if (level.weaponclass["shotgun"].allies_limited || !level.weapons[weaponname].allow)
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 0);
				else
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 1);
			}
			else if (level.weapons[weaponname].classname == "shotgun" && player.pers["team"] == "axis")
			{
				if (level.weaponclass["shotgun"].axis_limited || !level.weapons[weaponname].allow)
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 0);
				else
					player setClientCvar(level.weapons[weaponname].client_allowcvar, 1);
			}
		}

		//American Enfield
		if (game["allies"] == "american" && level.am_enfield && level.weapons["enfield_mp"].allow && !level.weaponclass["boltaction"].allies_limited)
			player setClientCvar("ui_allow_am_enfield", 1);
		else
			player setClientCvar("ui_allow_am_enfield", 0);
	}
}

Update_One_Weapon_HUDs(client_dvar, allowed)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if (allowed)
			player setClientCvar(client_dvar, 1);
		else
			player setClientCvar(client_dvar, 0);
	}
}

Update_WeaponClass_HUDs(team, weaponclass, allowed)
{
	if (!isDefined(allowed))
	{
		iprintln("Error: Allowed not sent to Update_WeaponClass_HUDs()");
		return;
	}

	for(weaponname = 0; weaponname < level.weaponnames.size; weaponname++)
	{
		name = level.weaponnames[weaponname];
		if (level.weapons[name].classname != weaponclass)
			continue;

		if (level.weaponnames[weaponname] == "enfield_mp" && game["allies"] == "american")
		{
			if (!allowed)
				thread Update_One_Weapon_HUDs("ui_allow_am_enfield", 0);

			if (allowed && getcvar("scr_allow_american_enfield") != "" && getcvarint("scr_allow_american_enfield") > 0)
				thread Update_One_Weapon_HUDs("ui_allow_am_enfield", 1);

			wait .05;
			continue;
		}

		if (weaponclass == "shotgun")
		{
			thread Update_Shotgun_Weapon_HUDs(team);
			return;
		}

		if (level.weapons[name].team != team)
			continue;

		thread Update_One_Weapon_HUDs(level.weapons[name].client_allowcvar, allowed);
		wait 0.05;
	}
}

Update_Shotgun_Weapon_HUDs(team)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if (!isDefined(player.pers["team"]))
			continue;

		if (player.pers["team"] != team)
			continue;

		if (team == "allies")
		{
			if(level.weaponclass["shotgun"].allies_limited)
				player setClientCvar(level.weapons["shotgun_mp"].client_allowcvar, 0);
			else
				player setClientCvar(level.weapons["shotgun_mp"].client_allowcvar, 1);
		}
		else if (team == "axis")
		{
			if(level.weaponclass["shotgun"].axis_limited)
				player setClientCvar(level.weapons["shotgun_mp"].client_allowcvar, 0);
			else
				player setClientCvar(level.weapons["shotgun_mp"].client_allowcvar, 1);
		}
	}
}


Update_All_Weapon_Limits()
{
	// Needs to be called when weapon statuses may have changed:
	// Player Disconnect, Player Changes Teams, Player goes to Spec
	al_sniper_count = 0;
	al_sniper_was_limited = level.weaponclass["sniper"].allies_limited;
	ax_sniper_count = 0;
	ax_sniper_was_limited = level.weaponclass["sniper"].axis_limited;

	al_boltaction_count = 0;
	al_boltaction_was_limited = level.weaponclass["boltaction"].allies_limited;
	ax_boltaction_count = 0;
	ax_boltaction_was_limited = level.weaponclass["boltaction"].axis_limited;

	al_semiauto_count = 0;
	al_semiauto_was_limited = level.weaponclass["semiautomatic"].allies_limited;
	ax_semiauto_count = 0;
	ax_semiauto_was_limited = level.weaponclass["semiautomatic"].axis_limited;

	al_smg_count = 0;
	al_smg_was_limited = level.weaponclass["smg"].allies_limited;
	ax_smg_count = 0;
	ax_smg_was_limited = level.weaponclass["smg"].axis_limited;

	al_mg_count = 0;
	al_mg_was_limited = level.weaponclass["mg"].allies_limited;
	ax_mg_count = 0;
	ax_mg_was_limited = level.weaponclass["mg"].axis_limited;

	al_shottie_count = 0;
	al_shottie_was_limited = level.weaponclass["shotgun"].allies_limited;
	ax_shottie_count = 0;
	ax_shottie_was_limited = level.weaponclass["shotgun"].axis_limited;

	Check_WeaponLimit_Server_Changes();

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if (!isDefined(player.pers["team"]) || (player.pers["team"] != "axis" || player.pers["team"] != "allies") )
			continue;

		if (!isDefined(player.pers["weapon"]))
			continue;
		spawnweapon = player.pers["weapon"];

		switch (level.weapons[spawnweapon].classname)
		{
		case "sniper":
			if (player.pers["team"] == "axis") ax_sniper_count++;
			else al_sniper_count++;
			break;
		case "boltaction":
			if (player.pers["team"] == "axis") ax_boltaction_count++;
			else al_boltaction_count++;
			break;
		case "semiautomatic":
			if (player.pers["team"] == "axis") ax_semiauto_count++;
			else al_semiauto_count++;
			break;
		case "smg":
			if (player.pers["team"] == "axis") ax_smg_count++;
			else al_smg_count++;
			break;
		case "mg":
			if (player.pers["team"] == "axis") ax_mg_count++;
			else al_mg_count++;
			break;
		case "shotgun":
			if (player.pers["team"] == "axis") ax_shottie_count++;
			else al_shottie_count++;
			break;
		default:
			//println("^3Weapon Limiter: " + spawnweapon + " has no weapon class");
		}

		if (level.allow_secondary && isDefined(player.pers["secondary_weapon"]))
		{
			secondary = player.pers["secondary_weapon"];

			switch (level.weapons[secondary].classname)
			{
			case "sniper":
				if (player.pers["team"] == "axis") ax_sniper_count++;
				else al_sniper_count++;
				break;
			case "boltaction":
				if (player.pers["team"] == "axis") ax_boltaction_count++;
				else al_boltaction_count++;
				break;
			case "semiautomatic":
				if (player.pers["team"] == "axis") ax_semiauto_count++;
				else al_semiauto_count++;
				break;
			case "smg":
				if (player.pers["team"] == "axis") ax_smg_count++;
				else al_smg_count++;
				break;
			case "mg":
				if (player.pers["team"] == "axis") ax_mg_count++;
				else al_mg_count++;
				break;
			case "shotgun":
				if (player.pers["team"] == "axis") ax_shottie_count++;
				else al_shottie_count++;
				break;
			default:
				//println("^3Weapon Limiter: " + spawnweapon + " has no weapon class");
			}
		}
	}

	if (al_sniper_count >= level.weaponclass["sniper"].limit) level.weaponclass["sniper"].allies_limited = 1;
	else level.weaponclass["sniper"].allies_limited = 0;
	if (ax_sniper_count >= level.weaponclass["sniper"].limit) level.weaponclass["sniper"].axis_limited = 1;
	else level.weaponclass["sniper"].axis_limited = 0;

	if (al_boltaction_count >= level.weaponclass["boltaction"].limit) level.weaponclass["boltaction"].allies_limited = 1;
	else level.weaponclass["boltaction"].allies_limited = 0;
	if (ax_boltaction_count >= level.weaponclass["boltaction"].limit) level.weaponclass["boltaction"].axis_limited = 1;
	else level.weaponclass["boltaction"].axis_limited = 0;

	if (al_semiauto_count >= level.weaponclass["semiautomatic"].limit) level.weaponclass["semiautomatic"].allies_limited = 1;
	else level.weaponclass["semiautomatic"].allies_limited = 0;
	if (ax_semiauto_count >= level.weaponclass["semiautomatic"].limit) level.weaponclass["semiautomatic"].axis_limited = 1;
	else level.weaponclass["semiautomatic"].axis_limited = 0;

	if (al_smg_count >= level.weaponclass["smg"].limit) level.weaponclass["smg"].allies_limited = 1;
	else level.weaponclass["smg"].allies_limited = 0;
	if (ax_smg_count >= level.weaponclass["smg"].limit) level.weaponclass["smg"].axis_limited = 1;
	else level.weaponclass["smg"].axis_limited = 0;

	if (al_mg_count >= level.weaponclass["mg"].limit) level.weaponclass["mg"].allies_limited = 1;
	else level.weaponclass["mg"].allies_limited = 0;
	if (ax_mg_count >= level.weaponclass["mg"].limit) level.weaponclass["mg"].axis_limited = 1;
	else level.weaponclass["mg"].axis_limited = 0;

	if (al_shottie_count >= level.weaponclass["shotgun"].limit) level.weaponclass["shotgun"].allies_limited = 1;
	else level.weaponclass["shotgun"].allies_limited = 0;
	if (ax_shottie_count >= level.weaponclass["shotgun"].limit) level.weaponclass["shotgun"].axis_limited = 1;
	else level.weaponclass["shotgun"].axis_limited = 0;

	//thread Update_All_Weapon_HUDs();

	//Check for changes in 'limited' status
	if (al_sniper_was_limited != level.weaponclass["sniper"].allies_limited)
	{
		allowed = 1;
		if (level.weaponclass["sniper"].allies_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("allies", "sniper", allowed);
	}

	if (ax_sniper_was_limited != level.weaponclass["sniper"].axis_limited)
	{
		allowed = 1;
		if (level.weaponclass["sniper"].axis_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("axis", "sniper", allowed);
	}

	if (al_boltaction_was_limited != level.weaponclass["boltaction"].allies_limited)
	{
		allowed = 1;
		if (level.weaponclass["boltaction"].allies_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("allies", "boltaction", allowed);
	}

	if (ax_boltaction_was_limited != level.weaponclass["boltaction"].axis_limited)
	{
		allowed = 1;
		if (level.weaponclass["boltaction"].axis_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("axis", "boltaction", allowed);
	}

	if (al_semiauto_was_limited != level.weaponclass["semiautomatic"].allies_limited)
	{
		allowed = 1;
		if (level.weaponclass["semiautomatic"].allies_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("allies", "semiautomatic", allowed);
	}

	if (ax_semiauto_was_limited != level.weaponclass["semiautomatic"].axis_limited)
	{
		allowed = 1;
		if (level.weaponclass["semiautomatic"].axis_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("axis", "semiautomatic", allowed);
	}

	if (al_smg_was_limited != level.weaponclass["smg"].allies_limited)
	{
		allowed = 1;
		if (level.weaponclass["smg"].allies_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("allies", "smg", allowed);
	}

	if (ax_smg_was_limited != level.weaponclass["smg"].axis_limited)
	{
		allowed = 1;
		if (level.weaponclass["smg"].axis_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("axis", "smg", allowed);
	}

	if (al_mg_was_limited != level.weaponclass["mg"].allies_limited)
	{
		allowed = 1;
		if (level.weaponclass["mg"].allies_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("allies", "mg", allowed);
	}

	if (ax_mg_was_limited != level.weaponclass["mg"].axis_limited)
	{
		allowed = 1;
		if (level.weaponclass["mg"].axis_limited)
			allowed = 0;
		thread Update_WeaponClass_HUDs("axis", "mg", allowed);
	}

	if (al_shottie_was_limited != level.weaponclass["shotgun"].allies_limited)
	{
		allowed = 1;
		if (level.weaponclass["shotgun"].allies_limited)
			allowed = 0;
		thread Update_Shotgun_Weapon_HUDs("allies");
	}

	if (ax_shottie_was_limited != level.weaponclass["shotgun"].axis_limited)
	{
		allowed = 1;
		if (level.weaponclass["shotgun"].axis_limited)
			allowed = 0;
		thread Update_Shotgun_Weapon_HUDs("axis");
	}
}

Check_WeaponLimit_Server_Changes()
{
	level.weaponclass["boltaction"].limit = getcvarint("scr_boltaction_limit");
	level.weaponclass["sniper"].limit = getcvarint("scr_sniper_limit");
	level.weaponclass["semiautomatic"].limit = getcvarint("scr_semiautomatic_limit");
	level.weaponclass["smg"].limit = getcvarint("scr_smg_limit");
	level.weaponclass["mg"].limit = getcvarint("scr_mg_limit");
	level.weaponclass["shotgun"].limit = getcvarint("scr_shotgun_limit");
}